# line 1 "character.d"

# line 1 "character.d"
/*
 Copyright (C) 1994 M. Hagiya, W. Schelter, T. Yuasa

This file is part of GNU Common Lisp, herein referred to as GCL

GCL is free software; you can redistribute it and/or modify it under
the terms of the GNU LIBRARY GENERAL PUBLIC LICENSE as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCL is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public 
License for more details.

You should have received a copy of the GNU Library General Public License 
along with GCL; see the file COPYING.  If not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
	character.d

	character routines
*/

#include "include.h"

void
Lstandard_char_p()
{
# line 29 "character.d"

	int i;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 31 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 34 "character.d"

	i = char_code(c);
	if ((' ' <= i && i < '\177') || i == '\n')
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 37 "character.d"

	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 38 "character.d"

#undef c
}
# line 39 "character.d"


void
Lgraphic_char_p()
{
# line 41 "character.d"

	int i;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 43 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 46 "character.d"

	i = char_code(c);
	if (' ' <= i && i < '\177')
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 49 "character.d"

	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 50 "character.d"

#undef c
}
# line 51 "character.d"


void
Lalpha_char_p()
{
# line 53 "character.d"

	int i;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 55 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 58 "character.d"

	i = char_code(c);
	if (isalpha(i))
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 61 "character.d"

	else
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 63 "character.d"

#undef c
}
# line 64 "character.d"


void
Lupper_case_p()
{
# line 66 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 67 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 70 "character.d"

	if (isUpper(char_code(c)))
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 72 "character.d"

	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 73 "character.d"

#undef c
}
# line 74 "character.d"


void
Llower_case_p()
{
# line 76 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 77 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 80 "character.d"

	if (isLower(char_code(c)))
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 82 "character.d"

	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 83 "character.d"

#undef c
}
# line 84 "character.d"


void
Lboth_case_p()
{
# line 86 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 87 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 90 "character.d"

	if (isUpper(char_code(c)) || isLower(char_code(c)))
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 92 "character.d"

	else
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 94 "character.d"

#undef c
}
# line 95 "character.d"


/*
	Digitp(i, r) returns the weight of code i
	as a digit of radix r.
	If r > 36 or i is not a digit, -1 is returned.
*/
int
digitp(i, r)
int i, r;
{
	if ('0' <= i && i <= '9' && 1 < r && i < '0' + r)
		return(i - '0');
	if ('A' <= i && 10 < r && r <= 36 && i < 'A' + (r - 10))
		return(i - 'A' + 10);
	if ('a' <= i && 10 < r && r <= 36 && i < 'a' + (r - 10))
		return(i - 'a' + 10);
	return(-1);
}

void
Ldigit_char_p()
{
# line 115 "character.d"

	int d;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]
#define	r	DPPbase[1+0]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();
	if (narg <= 1 + 0) {
		vs_push(make_fixnum(10));
		narg++;
	}
	if (narg > 1 + 1)
		too_many_arguments();

# line 117 "character.d"

	check_type_character(&c);
	check_type_non_negative_integer(&r);
	if (type_of(r) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 121 "character.d"

	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 123 "character.d"

	d = digitp(char_code(c), fix(r));
	if (d < 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 126 "character.d"

	{
		vs_base[0] = make_fixnum(d);
		vs_top = vs_base + 1;
		return;
	}
# line 127 "character.d"

#undef c
#undef r
}
# line 128 "character.d"


void
Lalphanumericp()
{
# line 130 "character.d"

	int i;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 132 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 135 "character.d"

	i = char_code(c);
	if (isalphanum(i))
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 138 "character.d"

	else
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 140 "character.d"

#undef c
}
# line 141 "character.d"


bool
char_eq(x, y)
object x, y;
{
	return(char_code(x) == char_code(y)
	    && char_bits(x) == char_bits(y)
	    && char_font(x) == char_font(y));
}

void
Lchar_eq()
{
# line 152 "character.d"

	int i;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();

# line 154 "character.d"

	check_type_character(&c);
	for (i = 0;  i < narg;  i++)
		check_type_character(&vs_base[i]);
	for (i = 1;  i < narg;  i++)
		if (!char_eq(vs_base[i-1], vs_base[i]))
			{
				vs_base[0] = Cnil;
				vs_top = vs_base + 1;
				return;
			}
# line 160 "character.d"

	{
		vs_base[0] = Ct;
		vs_top = vs_base + 1;
		return;
	}
# line 161 "character.d"

#undef c
}
# line 162 "character.d"


void
Lchar_neq()
{
# line 164 "character.d"

	int i, j;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();

# line 166 "character.d"

	check_type_character(&c);
	for (i = 0;  i < narg;  i++)
		check_type_character(&vs_base[i]);
	if (narg == 0)
		{
			vs_base[0] = Ct;
			vs_top = vs_base + 1;
			return;
		}
# line 171 "character.d"

	for (i = 1;  i < narg;  i++)
		for (j = 0;  j < i;  j++)
			if (char_eq(vs_base[j], vs_base[i]))
				{
					vs_base[0] = Cnil;
					vs_top = vs_base + 1;
					return;
				}
# line 175 "character.d"

	{
		vs_base[0] = Ct;
		vs_top = vs_base + 1;
		return;
	}
# line 176 "character.d"

#undef c
}
# line 177 "character.d"



static int
char_cmp(x, y)
object x, y;
{
	if (char_font(x) < char_font(y))
		return(-1);
	if (char_font(x) > char_font(y))
		return(1);
	if (char_bits(x) < char_bits(y))
		return(-1);
	if (char_bits(x) > char_bits(y))
		return(1);
	if (char_code(x) < char_code(y))
		return(-1);
	if (char_code(x) > char_code(y))
		return(1);
	return(0);
}

static void
Lchar_cmp(s, t)
int s, t;
{
	int narg, i;

	narg = vs_top - vs_base;
	if (narg == 0)
		too_few_arguments();
	for (i = 0; i < narg; i++)
		check_type_character(&vs_base[i]);
	for (i = 1; i < narg; i++)
		if (s*char_cmp(vs_base[i], vs_base[i-1]) < t) {
			vs_top = vs_base+1;
			vs_base[0] = Cnil;
			return;
		}
	vs_top = vs_base+1;
	vs_base[0] = Ct;
}

LFD(Lchar_l)()  { Lchar_cmp( 1, 1); }
LFD(Lchar_g)()  { Lchar_cmp(-1, 1); }
LFD(Lchar_le)() { Lchar_cmp( 1, 0); }
LFD(Lchar_ge)() { Lchar_cmp(-1, 0); }


bool
char_equal(x, y)
object x, y;
{
	int i, j;

	i = char_code(x);
	j = char_code(y);
	if (isLower(i))
		i -= 'a' - 'A';
	if (isLower(j))
		j -= 'a' - 'A';
	return(i == j);
}

void
Lchar_equal()
{
# line 241 "character.d"

	int i;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();

# line 243 "character.d"

	check_type_character(&c);
	for (i = 0;  i < narg;  i++)
		check_type_character(&vs_base[i]);
	for (i = 1;  i < narg;  i++)
		if (!char_equal(vs_base[i-1], vs_base[i]))
			{
				vs_base[0] = Cnil;
				vs_top = vs_base + 1;
				return;
			}
# line 249 "character.d"

	{
		vs_base[0] = Ct;
		vs_top = vs_base + 1;
		return;
	}
# line 250 "character.d"

#undef c
}
# line 251 "character.d"


void
Lchar_not_equal()
{
# line 253 "character.d"

	int i, j;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();

# line 255 "character.d"

	check_type_character(&c);
	for (i = 0;  i < narg;  i++)
		check_type_character(&vs_base[i]);
	for (i = 1;  i < narg;  i++)
		for (j = 0;  j < i;  j++)
			if (char_equal(vs_base[j], vs_base[i]))
				{
					vs_base[0] = Cnil;
					vs_top = vs_base + 1;
					return;
				}
# line 262 "character.d"

	{
		vs_base[0] = Ct;
		vs_top = vs_base + 1;
		return;
	}
# line 263 "character.d"

#undef c
}
# line 264 "character.d"



static int
char_compare(x, y)
object x, y;
{
	int i, j;

	i = char_code(x);
	j = char_code(y);
	if (isLower(i))
		i -= 'a' - 'A';
	if (isLower(j))
		j -= 'a' - 'A';
	if (i < j)
		return(-1);
	else if (i == j)
		return(0);
	else
		return(1);
}

static void
Lchar_compare(s, t)
int s, t;
{
	int narg, i;

	narg = vs_top - vs_base;
	if (narg == 0)
		too_few_arguments();
	for (i = 0; i < narg; i++)
		check_type_character(&vs_base[i]);
	for (i = 1; i < narg; i++)
		if (s*char_compare(vs_base[i], vs_base[i-1]) < t) {
			vs_top = vs_base+1;
			vs_base[0] = Cnil;
			return;
		}
	vs_top = vs_base+1;
	vs_base[0] = Ct;
}

LFD(Lchar_lessp)()        { Lchar_compare( 1, 1); }
LFD(Lchar_greaterp)()     { Lchar_compare(-1, 1); }
LFD(Lchar_not_greaterp)() { Lchar_compare( 1, 0); }
LFD(Lchar_not_lessp)()    { Lchar_compare(-1, 0); }


object
coerce_to_character(x)
object x;
{
BEGIN:
	switch (type_of(x)) {
	case t_fixnum:
		if (0 <= fix(x) && fix(x) < CHCODELIM)
			return(code_char(fix(x)));
		break;

	case t_character:
		return(x);

	case t_symbol:
	case t_string:
		if (x->st.st_fillp == 1)
			return(code_char(x->ust.ust_self[0]));
		break;
	default:
		break;
	}
	vs_push(x);
	x = wrong_type_argument(sLcharacter, x);
	vs_popp;
	goto BEGIN;
}

void
Lcharacter()
{
# line 342 "character.d"

	register object *DPPbase=vs_base;
#define	x	DPPbase[0]

	check_arg(1);

# line 343 "character.d"

	{
		vs_base[0] = coerce_to_character(x);
		vs_top = vs_base + 1;
		return;
	}
# line 344 "character.d"

#undef x
}
# line 345 "character.d"


void
Lchar_code()
{
# line 347 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 348 "character.d"

	check_type_character(&c);
	{
		vs_base[0] = make_fixnum(char_code(c));
		vs_top = vs_base + 1;
		return;
	}
# line 350 "character.d"

#undef c
}
# line 351 "character.d"


void
Lcode_char()
{
# line 353 "character.d"

	object x;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]
#define	b	DPPbase[1+0]
#define	f	DPPbase[1+1]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();
	if (narg <= 1 + 0) {
		vs_push(make_fixnum(0));
		narg++;
	}
	if (narg <= 1 + 1) {
		vs_push(make_fixnum(0));
		narg++;
	}
	if (narg > 1 + 2)
		too_many_arguments();

# line 355 "character.d"

	check_type_non_negative_integer(&c);
	check_type_non_negative_integer(&b);
	check_type_non_negative_integer(&f);
	if (type_of(c) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 360 "character.d"

	if (type_of(b) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 362 "character.d"

	if (type_of(f) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 364 "character.d"

	if (fix(c)>=CHCODELIM || fix(b)>=CHBITSLIM || fix(f)>=CHFONTLIM)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 366 "character.d"

	if (fix(b) == 0 && fix(f) == 0)
		{
			vs_base[0] = code_char(fix(c));
			vs_top = vs_base + 1;
			return;
		}
# line 368 "character.d"

	x = alloc_object(t_character);
	char_code(x) = fix(c);
	char_bits(x) = fix(b);
	char_font(x) = fix(f);
	{
		vs_base[0] = x;
		vs_top = vs_base + 1;
		return;
	}
# line 373 "character.d"

#undef c
#undef b
#undef f
}
# line 374 "character.d"


void
Lchar_upcase()
{
# line 376 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 377 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = c;
			vs_top = vs_base + 1;
			return;
		}
# line 380 "character.d"

	if (isLower(char_code(c)))
		{
			vs_base[0] = code_char(char_code(c) - ('a' - 'A'));
			vs_top = vs_base + 1;
			return;
		}
# line 382 "character.d"

	else
		{
			vs_base[0] = c;
			vs_top = vs_base + 1;
			return;
		}
# line 384 "character.d"

#undef c
}
# line 385 "character.d"


void
Lchar_downcase()
{
# line 387 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 388 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 391 "character.d"

	if (isUpper(char_code(c)))
		{
			vs_base[0] = code_char(char_code(c) + ('a' - 'A'));
			vs_top = vs_base + 1;
			return;
		}
# line 393 "character.d"

	else
		{
			vs_base[0] = c;
			vs_top = vs_base + 1;
			return;
		}
# line 395 "character.d"

#undef c
}
# line 396 "character.d"


int
digit_weight(w, r)
int w, r;
{
	if (r < 2 || r > 36 || w < 0 || w >= r)
		return(-1);
	if (w < 10)
		return(w + '0');
	else
		return(w - 10 + 'A');
}

void
Ldigit_char()
{
# line 413 "character.d"

	object x;
	int dw;
	int narg;
	register object *DPPbase=vs_base;
#define	w	DPPbase[0]
#define	r	DPPbase[1+0]
#define	f	DPPbase[1+1]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();
	if (narg <= 1 + 0) {
		vs_push(make_fixnum(10));
		narg++;
	}
	if (narg <= 1 + 1) {
		vs_push(make_fixnum(0));
		narg++;
	}
	if (narg > 1 + 2)
		too_many_arguments();

# line 416 "character.d"

	check_type_non_negative_integer(&w);
	check_type_non_negative_integer(&r);
	check_type_non_negative_integer(&f);
	if (type_of(w) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 421 "character.d"

	if (type_of(r) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 423 "character.d"

	if (type_of(f) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 425 "character.d"

	dw = digit_weight(fix(w), fix(r));
	if (dw < 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 428 "character.d"

	if (fix(f) >= CHFONTLIM)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 430 "character.d"

	if (fix(f) == 0)
		{
			vs_base[0] = code_char(dw);
			vs_top = vs_base + 1;
			return;
		}
# line 432 "character.d"

	x = alloc_object(t_character);
	char_code(x) = dw;
	char_bits(x) = 0;
	char_font(x) = fix(f);
	{
		vs_base[0] = x;
		vs_top = vs_base + 1;
		return;
	}
# line 437 "character.d"

#undef w
#undef r
#undef f
}
# line 438 "character.d"


void
Lchar_int()
{
# line 440 "character.d"

	int i;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 442 "character.d"

	check_type_character(&c);
	i = (char_font(c)*CHBITSLIM + char_bits(c))*CHCODELIM
	  + char_code(c);
	{
		vs_base[0] = make_fixnum(i);
		vs_top = vs_base + 1;
		return;
	}
# line 446 "character.d"

#undef c
}
# line 447 "character.d"


void
Lchar_name()
{
# line 449 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 450 "character.d"

	check_type_character(&c);
	if (char_bits(c) != 0 || char_font(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 453 "character.d"

	switch (char_code(c)) {
	case '\r':
		{
			vs_base[0] = STreturn;
			vs_top = vs_base + 1;
			return;
		}
# line 456 "character.d"


	case ' ':
		{
			vs_base[0] = STspace;
			vs_top = vs_base + 1;
			return;
		}
# line 459 "character.d"


	case '\177':
		{
			vs_base[0] = STrubout;
			vs_top = vs_base + 1;
			return;
		}
# line 462 "character.d"

	
	case '\f':
		{
			vs_base[0] = STpage;
			vs_top = vs_base + 1;
			return;
		}
# line 465 "character.d"


	case '\t':
		{
			vs_base[0] = STtab;
			vs_top = vs_base + 1;
			return;
		}
# line 468 "character.d"


	case '\b':
		{
			vs_base[0] = STbackspace;
			vs_top = vs_base + 1;
			return;
		}
# line 471 "character.d"


	case '\n':
		{
			vs_base[0] = STnewline;
			vs_top = vs_base + 1;
			return;
		}
# line 474 "character.d"

	}
	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 476 "character.d"

#undef c
}
# line 477 "character.d"


void
Lname_char()
{
# line 479 "character.d"

	register object *DPPbase=vs_base;
#define	s	DPPbase[0]

	check_arg(1);

# line 480 "character.d"

	s = coerce_to_string(s);
	if (string_equal(s, STreturn))
		{
			vs_base[0] = code_char('\r');
			vs_top = vs_base + 1;
			return;
		}
# line 483 "character.d"

	if (string_equal(s, STspace))
		{
			vs_base[0] = code_char(' ');
			vs_top = vs_base + 1;
			return;
		}
# line 485 "character.d"

	if (string_equal(s, STrubout))
		{
			vs_base[0] = code_char('\177');
			vs_top = vs_base + 1;
			return;
		}
# line 487 "character.d"

	if (string_equal(s, STpage))
		{
			vs_base[0] = code_char('\f');
			vs_top = vs_base + 1;
			return;
		}
# line 489 "character.d"

	if (string_equal(s, STtab))
		{
			vs_base[0] = code_char('\t');
			vs_top = vs_base + 1;
			return;
		}
# line 491 "character.d"

	if (string_equal(s, STbackspace))
		{
			vs_base[0] = code_char('\b');
			vs_top = vs_base + 1;
			return;
		}
# line 493 "character.d"

	if (string_equal(s, STlinefeed) || string_equal(s, STnewline))
		{
			vs_base[0] = code_char('\n');
			vs_top = vs_base + 1;
			return;
		}
# line 495 "character.d"

	{
		vs_base[0] = Cnil;
		vs_top = vs_base + 1;
		return;
	}
# line 496 "character.d"

#undef s
}
# line 497 "character.d"


void
gcl_init_character()
{
	int i;

	for (i = 0;  i < CHCODELIM;  i++) {
	  object x=(object)(character_table+i);
	  set_type_of(x,t_character);
	  /* character_table[i].ch.t = (short)t_character; */
	  character_table[i].ch.ch_code = i;
	  character_table[i].ch.ch_font = 0;
	  character_table[i].ch.ch_bits = 0;
	}
#ifdef AV
	for (i = -128;  i < 0;  i++) {
		character_table[i].ch.t = (short)t_character;
		character_table[i].ch.ch_code = i+CHCODELIM;
		character_table[i].ch.ch_font = 0;
		character_table[i].ch.ch_bits = 0;
	}
#endif

 	make_constant("CHAR-CODE-LIMIT", make_fixnum(CHCODELIM));
 	make_si_constant("CHAR-FONT-LIMIT", make_fixnum(CHFONTLIM));
 	make_si_constant("CHAR-BITS-LIMIT", make_fixnum(CHBITSLIM));

	STreturn = make_simple_string("Return");
	enter_mark_origin(&STreturn);
	STspace = make_simple_string("Space");
	enter_mark_origin(&STspace);
	STrubout = make_simple_string("Rubout");
	enter_mark_origin(&STrubout);
	STpage = make_simple_string("Page");
	enter_mark_origin(&STpage);
	STtab = make_simple_string("Tab");
	enter_mark_origin(&STtab);
	STbackspace = make_simple_string("Backspace");
	enter_mark_origin(&STbackspace);
	STlinefeed = make_simple_string("Linefeed");
	enter_mark_origin(&STlinefeed);

	STnewline = make_simple_string("Newline");
	enter_mark_origin(&STnewline);

	make_si_constant("CHAR-CONTROL-BIT", make_fixnum(0));
	make_si_constant("CHAR-META-BIT", make_fixnum(0));
	make_si_constant("CHAR-SUPER-BIT", make_fixnum(0));
	make_si_constant("CHAR-HYPER-BIT", make_fixnum(0));

}

void
Lmake_char()
{
# line 550 "character.d"

	object x;
	int code;
	int narg;
	register object *DPPbase=vs_base;
#define	c	DPPbase[0]
#define	b	DPPbase[1+0]
#define	f	DPPbase[1+1]

	narg = vs_top - vs_base;
	if (narg < 1)
		too_few_arguments();
	if (narg <= 1 + 0) {
		vs_push(make_fixnum(0));
		narg++;
	}
	if (narg <= 1 + 1) {
		vs_push(make_fixnum(0));
		narg++;
	}
	if (narg > 1 + 2)
		too_many_arguments();

# line 553 "character.d"

	check_type_character(&c);
	code = char_code(c);
	check_type_non_negative_integer(&b);
	check_type_non_negative_integer(&f);
	if (type_of(b) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 559 "character.d"

	if (type_of(f) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 561 "character.d"

	if (fix(b)>=CHBITSLIM || fix(f)>=CHFONTLIM)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 563 "character.d"

	if (fix(b) == 0 && fix(f) == 0)
		{
			vs_base[0] = code_char(code);
			vs_top = vs_base + 1;
			return;
		}
# line 565 "character.d"

	x = alloc_object(t_character);
	char_code(x) = code;
	char_bits(x) = fix(b);
	char_font(x) = fix(f);
	{
		vs_base[0] = x;
		vs_top = vs_base + 1;
		return;
	}
# line 570 "character.d"

#undef c
#undef b
#undef f
}
# line 571 "character.d"


void
Lchar_bits()
{
# line 573 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 574 "character.d"

	check_type_character(&c);
	{
		vs_base[0] = small_fixnum(char_bits(c));
		vs_top = vs_base + 1;
		return;
	}
# line 576 "character.d"

#undef c
}
# line 577 "character.d"


void
Lchar_font()
{
# line 579 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 580 "character.d"

	check_type_character(&c);
	{
		vs_base[0] = small_fixnum(char_font(c));
		vs_top = vs_base + 1;
		return;
	}
# line 582 "character.d"

#undef c
}
# line 583 "character.d"


void
Lchar_bit()
{
# line 585 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]
#define	n	DPPbase[1]

	check_arg(2);

# line 586 "character.d"

	check_type_character(&c);
	FEerror("Cannot get char-bit of ~S.", 1, c);
#undef c
#undef n
}
# line 589 "character.d"


void
Lset_char_bit()
{
# line 591 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]
#define	n	DPPbase[1]
#define	v	DPPbase[2]

	check_arg(3);

# line 592 "character.d"

	check_type_character(&c);
	FEerror("Cannot set char-bit of ~S.", 1, c);
#undef c
#undef n
#undef v
}
# line 595 "character.d"


void
Lstring_char_p()
{
# line 597 "character.d"

	register object *DPPbase=vs_base;
#define	c	DPPbase[0]

	check_arg(1);

# line 598 "character.d"

	check_type_character(&c);
	if (char_font(c) != 0 || char_bits(c) != 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 601 "character.d"

	{
		vs_base[0] = Ct;
		vs_top = vs_base + 1;
		return;
	}
# line 602 "character.d"

#undef c
}
# line 603 "character.d"


void
Lint_char()
{
# line 605 "character.d"

	int i, c, b, f;
	register object *DPPbase=vs_base;
#define	x	DPPbase[0]

	check_arg(1);

# line 607 "character.d"

	check_type_non_negative_integer(&x);
	if (type_of(x) == t_bignum)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 610 "character.d"

	i = fix(x);
	c = i % CHCODELIM;
	i /= CHCODELIM;
	b = i % CHBITSLIM;
	i /= CHBITSLIM;
	f = i % CHFONTLIM;
	i /= CHFONTLIM;
	if (i > 0)
		{
			vs_base[0] = Cnil;
			vs_top = vs_base + 1;
			return;
		}
# line 619 "character.d"

	if (b == 0 && f == 0)
		{
			vs_base[0] = code_char(c);
			vs_top = vs_base + 1;
			return;
		}
# line 621 "character.d"

	x = alloc_object(t_character);
	char_code(x) = c;
	char_bits(x) = b;
	char_font(x) = f;
	{
		vs_base[0] = x;
		vs_top = vs_base + 1;
		return;
	}
# line 626 "character.d"

#undef x
}
# line 627 "character.d"


void
gcl_init_character_function()
{
	make_function("STANDARD-CHAR-P", Lstandard_char_p);
	make_function("GRAPHIC-CHAR-P", Lgraphic_char_p);
	make_function("ALPHA-CHAR-P", Lalpha_char_p);
	make_function("UPPER-CASE-P", Lupper_case_p);
	make_function("LOWER-CASE-P", Llower_case_p);
	make_function("BOTH-CASE-P", Lboth_case_p);
	make_function("DIGIT-CHAR-P", Ldigit_char_p);
	make_function("ALPHANUMERICP", Lalphanumericp);
	make_function("CHAR=", Lchar_eq);
	make_function("CHAR/=", Lchar_neq);
	make_function("CHAR<", Lchar_l);
	make_function("CHAR>", Lchar_g);
	make_function("CHAR<=", Lchar_le);
	make_function("CHAR>=", Lchar_ge);
	make_function("CHAR-EQUAL", Lchar_equal);
	make_function("CHAR-NOT-EQUAL", Lchar_not_equal);
	make_function("CHAR-LESSP", Lchar_lessp);
	make_function("CHAR-GREATERP", Lchar_greaterp);
	make_function("CHAR-NOT-GREATERP", Lchar_not_greaterp);
	make_function("CHAR-NOT-LESSP", Lchar_not_lessp);
	make_function("CHARACTER", Lcharacter);
	make_function("CHAR-CODE", Lchar_code);
	make_function("CODE-CHAR", Lcode_char);
	make_function("CHAR-UPCASE", Lchar_upcase);
	make_function("CHAR-DOWNCASE", Lchar_downcase);
	make_function("DIGIT-CHAR", Ldigit_char);
	make_function("CHAR-INT", Lchar_int);
	make_function("CHAR-NAME", Lchar_name);
	make_function("NAME-CHAR", Lname_char);
	make_si_function("INT-CHAR", Lint_char);
	make_si_function("MAKE-CHAR", Lmake_char);
	make_si_function("CHAR-BITS", Lchar_bits);
	make_si_function("CHAR-FONT", Lchar_font);
	make_si_function("CHAR-BIT", Lchar_bit);
	make_si_function("SET-CHAR-BIT", Lset_char_bit);
	make_si_function("STRING-CHAR-P", Lstring_char_p);
}
